//****************************************************************************
//	aisa15w.pas
//
//	aISA-A15
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	Date 1998/03/05
//
//****************************************************************************

unit aisa15w;

interface

uses
	Windows;

{ Miscellaneous }
const
	AISA15_CH_MAX       = 16;								// A/Dِ
	AISA15_BUFF_PCH_MAX = 4096;				// 1ٓA/Dޯ̧MAX

{ őXbg }
const
	AISA15_MAX_SLOTS = 16;

{ _Xbgw }
const
  AISA15_SLOT_AUTO = Word(not 0);

{ G[R[h̒`}
const
	AISA15_ERR_INTERNAL	      = (-2); { Send mail to us }
  AISA15_ERR_UNKNOWN	      = (-1); { Help me! }
  AISA15_SUCCESS			      = 0;		{ I }
  AISA15_ERR_NO_DEVICE			= 1;		{ No device or not an aISA-A15 }
  AISA15_ERR_RESOURCE				= 2;		{ Resource exhaustion }
  AISA15_ERR_INV_ARG				= 3;		{ Invalid argument(s) }
  AISA15_ERR_SLOT					  = 100;	{ _Xbgԍsłi܂͌܂j}
  AISA15_ERR_CHANNEL				= 101;	{ `lw肪sł }
  AISA15_ERR_TIMER				  = 102;	{ ^C}lsł }
  AISA15_ERR_DMA_BUFFSIZE		=	103;	{ DMA]TCYsł }
  AISA15_ERR_NOT_ENOUGH_MEM	=	104;	{ \ȃmۂł܂ł }
  AISA15_ERR_DMA					  = 105;	{ DMA͎gpł܂ }
  AISA15_ERR_NUMDATA				= 106;	{ w肳ꂽ̃f[^obt@ɑ݂܂ }
  AISA15_ERR_NO_CREATE			= 107;	{ foCXNGCgĂ܂ }
  AISA15_ERR_START				  = 108;	{ X^[gɎs܂B }
  AISA15_ERR_INV_FUNC				= 109;	{ Ȋ֐Ăяoł }

{ TvO[h̒` }
const							{ START  SAMPLING	TRANSFER  CLK }
	MODE_01	= 1;		{ soft	 single	  port	    --- }
	MODE_02	= 2;		{ soft	 single	  port	    EXTRG }
	MODE_03	= 3;		{ soft	 burst		port	    timer }
	MODE_04	= 4;		{ soft	 burst		port	    EXTRG }
	MODE_05	= 5;		{ soft	 burst		DMA		    timer }
	MODE_06	= 6;		{ EXIN0  single	  port	    --- }
	MODE_07	= 7;		{ EXIN0  single	  port	    EXTRG }
	MODE_08	= 8;		{ EXIN0  burst		port	    timer }
	MODE_09	= 9;		{ EXIN0  burst		port	    EXTRG }
	MODE_10	= 10;		{ EXIN0  burst		DMA		    timer }

{ bZ[W }
const
	WM_EOC  			      = $6401;	{ VOTvO̊ }
	WM_BUFF_HALF_FULL		= $6402;	{ VxDOobt@̃n[tt }
	WM_BUFF_FULL				= $6403;	{ VxDOobt@̃t }
	WM_BUFF_OVERFLOW		= $6404;	{ VxDOobt@̃I[o[t[ }
	WM_SAMPLING_OVERRUN = $6405;	{ `lEI[gECNg̃I[o[ }
	WM_DMA_TC					  = $6406;	{ DMA] }

{ I/O\[XzE }
const
	AISA15_NMAX_MEM	= 9;	{ MAX_MEM_REGISTERS }
	AISA15_NMAX_IO	= 20;	{ MAX_IO_PORTS }
	AISA15_NMAX_IRQ	= 7;	{ MAX_IRQS }
	AISA15_NMAX_DMA	= 7;	{ MAX_DMA_CHANNELS }

{ ***** I/O\[X\ ***** }
{ YfoCXgpI/O\[XAvP[V󂯎邽߂̍\́B }
type
		TAISA15RESOURCE = record
			wNumMemWindows:Word;																{ EBhE }
			dMemBase:      array [1..AISA15_NMAX_MEM] of DWord;	{ EBhEJnAhX }
			dMemLength:    array [1..AISA15_NMAX_MEM] of DWord;	{ EBhE }
			wMemAttrib:    array [1..AISA15_NMAX_MEM] of Word;	{ EBhE }
			wNumIOPorts:   Word;																{ I/O|[g }
			wIOPortBase:   array [1..AISA15_NMAX_IO] of Word;		{ I/O|[gJnAhX }
			wIOPortLength: array [1..AISA15_NMAX_IO] of Word;		{ I/O|[g }
			wNumIRQs:      Word;																{ IRQ }
			bIRQRegisters: array [1..AISA15_NMAX_IRQ] of Byte;	{ IRQԍ }
			bIRQAttrib:    array [1..AISA15_NMAX_IRQ] of Byte;	{ IRQ }
			wNumDMAs:      Word;																{ DMA`l }
			bDMALst:       array [1..AISA15_NMAX_DMA] of Byte;	{ DMA`l }
			wDMAAttrib:    array [1..AISA15_NMAX_DMA] of Word;	{ DMA`l }
			bReserved1:    array [1..3] of Byte;								{ \ }
		end;

PAISA15RESOURCE = ^TAISA15RESOURCE;


{ ***** TvO[h\ ***** }
{ YfoCX̃TvO[hɊւVxD֓n߂̍\́B }
{ iChFirstiChLast𓯂lɂ邱ƂŃ`lEI[gECNgȂ[hƂȂB }
type
		TAISA15MODE = record
			iChFirst: DWORD;	{ TvOJn`l(0 ` 15) }
			iChLast:  DWORD;	{ TvOI`l(0 ` 15) }
			cwBuffer: DWORD;	{ obt@TCYi[hPʁj }
			dwTimer:  DWORD;	{ ^C}l(1`50000000) }
			dwMode:   DWORD;	{ 샂[h(1`10) }
    end;

PAISA15MODE = ^TAISA15MODE;

type
	{ A/Dޯ̧ }
	TADBUFF = array [1..AISA15_CH_MAX, 1..AISA15_BUFF_PCH_MAX] of Word;
	TVXDBUFF = array [1..(AISA15_CH_MAX) * (AISA15_BUFF_PCH_MAX-1)] of Word;
	PADBUFF = ^TADBUFF;
	PVXDNUFF = ^TVXDBUFF;

const
	AISA15_ERR_WRAPDLL = DWord(-3); { bp[֐G[ }

const
	AISA15_DLL_NAME = 'aisa15.dll';		{ DLL }


function Aisa15wDllOpen: Boolean;		{ DLL [h }
function Aisa15wDllClose: Boolean;	{ DLL A[h }


{ foCXhCoDLL̃o[W擾 }
function Aisa15wGetVersion(var pdwDllVer: DWord; var pdwDrvVer: DWord): Boolean;


{ foCX̎gp錾 }
function Aisa15wCreate(var pwLogSlot: Word; hWnd: THandle; var pvInitArg): Boolean;
{ foCX̊J錾 }
function Aisa15wClose(wLogSlot: Word): Boolean;


{ I/O\[X̎擾 }
function Aisa15wGetResource(wLogSlot: Word; pres: PAISA15RESOURCE): Boolean;


{ TvO[h̐ݒ }
function Aisa15wSetMode(wLogSlot: Word; pcmode: PAISA15MODE): Boolean;
{ TvOJn }
function Aisa15wStartSampling(wLogSlot: Word): Boolean;
{ TvO~ }
function Aisa15wStopSampling(wLogSlot: Word): Boolean;
{ TvOEXe[^X̎擾 }
function Aisa15wGetSamplingStatus(wLogSlot: Word; var pcwNumData: DWord; var pdwStatus: DWord): Boolean;
{ TvOς݃f[^̎擾 }
function Aisa15wGetData(wLogSlot: Word; cwNumData: DWord; Data:PADBUFF): Boolean;
{ O͏Ԃ̎擾 }
function Aisa15wGetExIn(wLogSlot: Word; var pdwExIn0: DWord; var pdwExIn1: DWord; var pdwExTrg: DWord): Boolean;


{ G[R[h̎擾 }
function Aisa15wGetLastError(wLogSlot: Word): DWord;

implementation

type
	TAisa15GetVersion = function(var pdwDllVer: DWord; var pdwDrvVer: DWord): Bool; stdcall;
	TAisa15Create = function(var pwLogSlot: Word; hWnd: THandle; var pvInitArg): Bool; stdcall;
	TAisa15Close = function(wLogSlot: Word): Bool; stdcall;
	TAisa15GetResource = function(wLogSlot: Word; pres: PAISA15RESOURCE): Bool; stdcall;
	TAisa15SetMode = function(wLogSlot: Word; pcmode: PAISA15MODE): Bool; stdcall;
	TAisa15StartSampling = function(wLogSlot: Word): Bool; stdcall;
	TAisa15StopSampling = function(wLogSlot: Word): Bool; stdcall;
	TAisa15GetSamplingStatus = function(wLogSlot: Word; var pcwNumData: DWord; var pdwStatus: DWord): Bool; stdcall;
	TAisa15GetData = function(wLogSlot: Word; cwNumData: DWord; Data:PADBUFF): Bool; stdcall;
	TAisa15GetExIn = function(wLogSlot: Word; var pdwExIn0: DWord; var pdwExIn1: DWord; var pdwExTrg: DWord): Bool; stdcall;
	TAisa15GetLastError = function(wLogSlot: Word): DWord; stdcall;

function Aisa15wGetDllExportFunc: Boolean; forward;

{$J+}
const
	hDLL: THandle = 0;
{$J-}

{ DLL GNX|[g֐AhX̊i[ϐ }
var
	pAisa15GetVersion: TAisa15GetVersion;
	pAisa15Create: TAisa15Create;
	pAisa15Close: TAisa15Close;
	pAisa15GetResource: TAisa15GetResource;
	pAisa15SetMode: TAisa15SetMode;
	pAisa15StartSampling: TAisa15StartSampling;
	pAisa15StopSampling: TAisa15StopSampling;
	pAisa15GetSamplingStatus: TAisa15GetSamplingStatus;
	pAisa15GetData: TAisa15GetData;
	pAisa15GetExIn: TAisa15GetExIn;
	pAisa15GetLastError: TAisa15GetLastError;


//****************************************************************************
// 		aisa15.dll[h
// 		
// ߂l  True
//				s False
//****************************************************************************
function Aisa15wDllOpen: Boolean;
begin
	Result := False;

	if hDLL <> 0 then Exit;

	hDLL := LoadLibrary(AISA15_DLL_NAME);
	if hDLL = 0 then Exit;

	if Aisa15wGetDllExportFunc = False then
	begin
		Aisa15wDllClose;	// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		Exit;
	end;

	Result := True;
end;

//****************************************************************************
// 		aisa15.dllA[h
// 		
// ߂l  True
//				s False
//****************************************************************************
function Aisa15wDllClose: Boolean;
begin
	Result := True;

	if hDLL = 0 then Exit;

	if FreeLibrary(hDLL) = True then hDLL := 0
	else Result := False;
end;



//****************************************************************************
// 		aISA-A15 DLL,Vxd̃o[Wԍ擾
// 		pdwDllVer DLLo[Wԍi[
//				pdwDrvVer Vxdo[Wԍi[
// ߂l  True
//				s False
//****************************************************************************
function Aisa15wGetVersion(var pdwDllVer: DWord; var pdwDrvVer: DWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa15GetVersion(pdwDllVer, pdwDrvVer);
end;

//****************************************************************************
// 		aISA-A15̔Cӂ̃foCX̎gp錾
// 		pwLogSlot	 gpfoCXi[
//        hWnd       bZ[W𑗂EBhEnh
//        pvInitArg  gp
// ߂l  True
//				s False
//****************************************************************************
function Aisa15wCreate(var pwLogSlot: Word; hWnd: THandle; var pvInitArg): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa15Create(pwLogSlot, hWnd, pvInitArg);
end;

//****************************************************************************
// 		aISA-A15̔Cӂ̃foCX̎gpJ
// 		wLogSlot gpfoCX
// ߂l  True
//				s False
//****************************************************************************
function Aisa15wClose(wLogSlot: Word): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa15Close(wLogSlot);
end;

//****************************************************************************
// 		wfoCX̃\[X擾
// 		wLogSlot ׂfoCX
//				pres 		 \[Xi[\
// ߂l  True
//				s False
//****************************************************************************
function Aisa15wGetResource(wLogSlot: Word; pres: PAISA15RESOURCE): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa15GetResource(wLogSlot, pres);
end;

//****************************************************************************
// 		TvO[h̐ݒ
// 
// ߂l  True
//				s False
//****************************************************************************
function Aisa15wSetMode(wLogSlot: Word; pcmode: PAISA15MODE): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

  Result := pAisa15SetMode(wLogSlot, pcmode);
end;

//****************************************************************************
// 		TvOJn
// 
// ߂l  True
//				s False
//****************************************************************************
function Aisa15wStartSampling(wLogSlot: Word): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa15StartSampling(wLogSlot);
end;

//****************************************************************************
// 		TvO~
// 
// ߂l  True
//				s False
//****************************************************************************
function Aisa15wStopSampling(wLogSlot: Word): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa15StopSampling(wLogSlot);
end;

//****************************************************************************
// 		TvOEXe[^X̎擾
// 
// ߂l  True
//				s False
//****************************************************************************
function Aisa15wGetSamplingStatus(wLogSlot: Word; var pcwNumData: DWord; var pdwStatus: DWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa15GetSamplingStatus(wLogSlot, pcwNumData, pdwStatus);
end;

//****************************************************************************
// 		TvOς݃f[^̎擾
// 
// ߂l  True
//				s False
//****************************************************************************
function Aisa15wGetData(wLogSlot: Word; cwNumData: DWord; Data:PADBUFF): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

  Result := pAisa15GetData(wLogSlot, cwNumData, Data);
end;

//****************************************************************************
// 		O͏Ԃ̎擾
// 
// ߂l  True
//				s False
//****************************************************************************
function Aisa15wGetExIn(wLogSlot: Word; var pdwExIn0: DWord; var pdwExIn1: DWord; var pdwExTrg: DWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

  Result := pAisa15GetExIn(wLogSlot, pdwExIn0, pdwExIn1, pdwExTrg);
end;

//****************************************************************************
// 		aISA-A15̃G[R[h
// 		wLogSlot	G[foCX
// ߂l G[R[h
//****************************************************************************
function Aisa15wGetLastError(wLogSlot: Word): DWord;
begin
	Result := AISA15_ERR_WRAPDLL;

	if hDLL = 0 then Exit;

	Result := pAisa15GetLastError(wLogSlot);
end;

//---------------------------------------------------------------------------
// 		DLLGNX|[g֐AhX̎擾
// 		
// ߂l  True
//				s False
//---------------------------------------------------------------------------
function Aisa15wGetDllExportFunc: Boolean;
begin
	Result := False;

  // Aisa15GetVersion ̃AhX擾
	pAisa15GetVersion := GetProcAddress(hDLL, 'Aisa15GetVersion');
	if @pAisa15GetVersion = nil then Exit;

  // Aisa15Create ̃AhX擾
	pAisa15Create := GetProcAddress(hDLL, 'Aisa15Create');
	if @pAisa15Create = nil then Exit;

  // Aisa15Close ̃AhX擾
	pAisa15Close := GetProcAddress(hDLL, 'Aisa15Close');
	if @pAisa15Close = nil then Exit;

  // Aisa15GetResource ̃AhX擾
	pAisa15GetResource := GetProcAddress(hDLL, 'Aisa15GetResource');
	if @pAisa15GetResource = nil then Exit;

  // Aisa15SetMode ̃AhX擾
	pAisa15SetMode := GetProcAddress(hDLL, 'Aisa15SetMode');
	if @pAisa15SetMode = nil then Exit;

  // Aisa15StartSampling ̃AhX擾
	pAisa15StartSampling := GetProcAddress(hDLL, 'Aisa15StartSampling');
	if @pAisa15StartSampling = nil then Exit;

  // Aisa15StopSampling ̃AhX擾
	pAisa15StopSampling := GetProcAddress(hDLL, 'Aisa15StopSampling');
	if @pAisa15StopSampling = nil then Exit;

  // Aisa15GetSamplingStatus ̃AhX擾
	pAisa15GetSamplingStatus := GetProcAddress(hDLL, 'Aisa15GetSamplingStatus');
	if @pAisa15GetSamplingStatus = nil then Exit;

  // Aisa15GetData ̃AhX擾
	pAisa15GetData := GetProcAddress(hDLL, 'Aisa15GetData');
	if @pAisa15GetData = nil then Exit;

  // Aisa15GetExIn ̃AhX擾
	pAisa15GetExIn := GetProcAddress(hDLL, 'Aisa15GetExIn');
	if @pAisa15GetExIn = nil then Exit;

  // Aisa15GetLastError ̃AhX擾
	pAisa15GetLastError := GetProcAddress(hDLL, 'Aisa15GetLastError');
	if @pAisa15GetLastError = nil then Exit;

	Result := True;	// SĂ DLL GNX|[g֐AhX擾
end;

end.

