Attribute VB_Name = "Module1"
'-----------------------------------------------------------------------
'       aisa15.bas
'
'       AISA-A15 Win32 API.
'-----------------------------------------------------------------------

Option Explicit

' őXbg
Global Const AISA15_MAX_SLOTS = 16

' _Xbgw
Global Const AISA15_SLOT_AUTO = &HFFFF

' G[R[h̒`
Global Const AISA15_ERR_INTERNAL = (-2)         ' Send mail to us
Global Const AISA15_ERR_UNKNOWN = (-1)          ' Help me!
Global Const AISA15_SUCCESS = 0                 ' I
Global Const AISA15_ERR_NO_DEVICE = 1           ' No device or not an aISA-A15
Global Const AISA15_ERR_RESOURCE = 2            ' Resource exhaustion
Global Const AISA15_ERR_INV_ARG = 3             ' Invalid argument(s)
Global Const AISA15_ERR_SLOT = 100              ' _Xbgԍsłi܂͌܂j
Global Const AISA15_ERR_CHANNEL = 101           ' `lw肪sł
Global Const AISA15_ERR_TIMER = 102             ' ^C}lsł
Global Const AISA15_ERR_DMA_BUFFSIZE = 103      ' DMA]TCYsł
Global Const AISA15_ERR_NOT_ENOUGH_MEM = 104    ' \ȃmۂł܂ł
Global Const AISA15_ERR_DMA = 105               ' DMA͎gpł܂
Global Const AISA15_ERR_NUMDATA = 106           ' w肳ꂽ̃f[^obt@ɑ݂܂
Global Const AISA15_ERR_NO_CREATE = 107         ' foCXNGCgĂ܂
Global Const AISA15_ERR_START = 108             ' X^[gɎs܂B
Global Const AISA15_ERR_INV_FUNC = 109          ' Ȋ֐Ăяoł

' TvO[h̒`
                                            ' START  SAMPLING  TRANSFER  CLK
Global Const MODE_01 = 1                    ' soft   single    port      ---
Global Const MODE_02 = 2                    ' soft   single    port      EXTRG
Global Const MODE_03 = 3                    ' soft   burst     port      timer
Global Const MODE_04 = 4                    ' soft   burst     port      EXTRG
Global Const MODE_05 = 5                    ' soft   burst     DMA       timer
Global Const MODE_06 = 6                    ' EXIN0  single    port      ---
Global Const MODE_07 = 7                    ' EXIN0  single    port      EXTRG
Global Const MODE_08 = 8                    ' EXIN0  burst     port      timer
Global Const MODE_09 = 9                    ' EXIN0  burst     port      EXTRG
Global Const MODE_10 = 10                   ' EXIN0  burst     DMA       timer

' bZ[W
Global Const WM_EOC = &H6401                ' VOTvO̊
Global Const WM_BUFF_HALF_FULL = &H6402     ' VxDOobt@̃n[tt
Global Const WM_BUFF_FULL = &H6403          ' VxDOobt@̃t
Global Const WM_BUFF_OVERFLOW = &H6404      ' VxDOobt@̃I[o[t[
Global Const WM_SAMPLING_OVERRUN = &H6405   ' `lEI[gECNg̃I[o[
Global Const WM_DMA_TC = &H6406             ' DMA]

' I/O\[XzE
Global Const AISA15_NMAX_MEM = 9            ' MAX_MEM_REGISTERS
Global Const AISA15_NMAX_IO = 20            ' MAX_IO_PORTS
Global Const AISA15_NMAX_IRQ = 7            ' MAX_IRQS
Global Const AISA15_NMAX_DMA = 7            ' MAX_DMA_CHANNELS

' ***** I/O\[X\ *****
' YfoCXgpI/O\[XAvP[V󂯎邽߂̍\́B
Type AISA15RESOURCE
    wNumMemWindows As Integer                     ' EBhE
    dMemBase(1 To AISA15_NMAX_MEM) As Long        ' EBhEJnAhX
    dMemLength(1 To AISA15_NMAX_MEM) As Long      ' EBhE
    wMemAttrib(1 To AISA15_NMAX_MEM) As Integer   ' EBhE
    wNumIOPorts As Integer                        ' I/O|[g
    wIOPortBase(1 To AISA15_NMAX_IO) As Integer   ' I/O|[gJnAhX
    wIOPortLength(1 To AISA15_NMAX_IO) As Integer ' I/O|[g
    wNumIRQs As Integer                           ' IRQ
    bIRQRegisters(1 To AISA15_NMAX_IRQ) As Byte   ' IRQԍ
    bIRQAttrib(1 To AISA15_NMAX_IRQ) As Byte      ' IRQ
    wNumDMAs As Integer                           ' DMA`l
    bDMALst(1 To AISA15_NMAX_DMA) As Byte         ' DMA`l
    wDMAAttrib(1 To AISA15_NMAX_DMA) As Integer   ' DMA`l
    bReserved1(1 To 3) As Integer                 ' \
End Type


' ***** TvO[h\ *****
' YfoCX̃TvO[hɊւVxD֓n߂̍\́B
' iChFirstiChLast𓯂lɂ邱ƂŃ`lEI[gECNgȂ[hƂȂB
Type AISA15MODE
    iChFirst As Long        ' TvOJn`l(0 ` 15)
    iChLast As Long         ' TvOI`l(0 ` 15)
    cwBuffer As Long        ' obt@TCYi[hPʁj
    dwTimer As Long         ' ^C}l(1`50000000)
    dwMode As Long          ' 샂[h(1`10)
End Type

' foCX̎gp錾
Public Declare Function Aisa15Create Lib "aisa15" (ByRef pwLogSlot As Integer, ByVal hwnd As Long, ByRef pvInitArg As Variant) As Long

' foCX̊J錾
Public Declare Function Aisa15Close Lib "aisa15" (ByVal wLogSlot As Integer) As Long
              
' foCXhCoDLL̃o[W擾
Public Declare Function Aisa15GetVersion Lib "aisa15" (ByRef pdwDllVer As Long, ByRef pdwDrvVer As Long) As Long

' I/O\[X̎擾
Public Declare Function Aisa15GetResource Lib "aisa15" (ByVal wLogSlot As Integer, ByRef pres As AISA15RESOURCE) As Long

' TvO[h̐ݒ
Public Declare Function Aisa15SetMode Lib "aisa15" (ByVal wLogSlot As Integer, ByRef pcmode As AISA15MODE) As Long

' TvOJn
Public Declare Function Aisa15StartSampling Lib "aisa15" (ByVal wLogSlot As Integer) As Long

' TvO~
Public Declare Function Aisa15StopSampling Lib "aisa15" (ByVal wLogSlot As Integer) As Long

' TvOEXe[^X̎擾
Public Declare Function Aisa15GetSamplingStatus Lib "aisa15" (ByVal wLogSlot As Integer, ByRef pcwNumData As Long, ByRef pdwStatus As Long) As Long

' TvOς݃f[^̎擾
Public Declare Function Aisa15GetData Lib "aisa15" (ByVal wLogSlot As Integer, ByVal cwNumData As Long, ByRef pwData As Integer) As Long

' G[R[h̎擾
Public Declare Function Aisa15GetLastError Lib "aisa15" (ByVal wLogSlot As Integer) As Long

' O͏Ԃ̎擾
Public Declare Function Aisa15GetExIn Lib "aisa15" (ByVal wLogSlot As Integer, ByRef pdwExIn0 As Long, ByRef pdwExIn1 As Long, ByRef pdwExTrg As Long) As Long
