/******************************************************************************/
/*	aisa15s.c																  */
/*																			  */
/*	aISA-A15															  */
/*																			  */
/*	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.									  */
/*																			  */
/*	Date 1998/04/21															  */
/*																			  */
/*	̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B					  */
/*																			  */
/******************************************************************************/


#define	STRICT
#include	<windows.h>
#include	<tchar.h>

#include "aisa15w.h"


const TCHAR szTitle[] = _T("Sample");
const TCHAR szA15[]	 = _T("aISA-A15");

static void ResultMessage(LPCTSTR lpszbuf);
static void ErrorMessage(WORD wLogSlot);


int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	TCHAR szbuf[1024], szTmp[20];
	DWORD dwDLLVer, dwVxdVer;
	BOOL  bResult;					// 
	WORD  wLogSlot;					// foCXi[
	AISA15RESOURCE ri;				// \[X
	AISA15MODE	   md;				// TvO[h
	DWORD dwNumData;
	DWORD dwStatus;
	PWORD pwData;
	LONG  i;
	DWORD dwExIn0, dwExIn1, dwExTrg;

/*---------------------------------------------------------------------------*/
	// aisa15.dll ̎gp錾
	if (Aisa15wDllOpen() == FALSE)
	{
		ErrorMessage(AISA15_SLOT_AUTO);
		return 1;			// aisa15.dll ̃[hɎs܂
	}

/*---------------------------------------------------------------------------*/
	// o[Wԍ\
	// aISA-A15 DLL,VxD̃o[Wԍ擾
	if (Aisa15wGetVersion(&dwDLLVer, &dwVxdVer) == FALSE)
	{
		ErrorMessage(AISA15_SLOT_AUTO);
		return 1;
	}

	wsprintf(szbuf, _T("GetVersion\n")
					_T("DLL Version: %08lxh\n")
					_T("Vxd Version: %08lxh"),
					dwDLLVer,
					dwVxdVer);
	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// aISA-A15̎gp錾
	wLogSlot = AISA15_SLOT_AUTO;		// gp̃foCXT܂B
	bResult = Aisa15wCreate(&wLogSlot,	// ꍇA̎̃foCXi[܂B
							NULL,		// EBhEnhȂ̂NULLZbg܂B
										// EBhEnhZbg΁Ae탁bZ[W
										// ܂B
							NULL);

	if (bResult == FALSE)		// foCX܂B
	{
		ErrorMessage(AISA15_SLOT_AUTO);
		return 1;
	}

	wsprintf(szbuf, _T("aISA-A15 Created\n\n")
					_T("LogSlot: %2d"),
					 wLogSlot);

	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// \[X擾
	if (Aisa15wGetResource(wLogSlot, &ri) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	wsprintf(szbuf, _T("Board Name: %s\n")
					_T("NumPorts: %2d\n")
					_T("IO Address: %04xh-%04xh\n")
					_T("IRQ: %2d\n")
					_T("DMA: %2d"),
					szA15,
					ri.wIOPortLength[0],
					ri.wIOPortBase[0], ri.wIOPortBase[0] + ri.wIOPortLength[0] - 1,
					ri.bIRQRegisters[0],
					ri.bDMALst[0]);

	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// TvO[h̐ݒ
	md.iChFirst = 0;		// TvOJn`l(0 ` 15)
	md.iChLast	= 15;		// TvOI`l(0 ` 15)
	md.cwBuffer = 256;		// obt@TCYi[hPʁj
	md.dwTimer	= 500;		// ^C}l(1`50000000)
	md.dwMode	= MODE_03;	// 샂[h(1`10)

	if (Aisa15wSetMode(wLogSlot, &md) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	wsprintf(szbuf, _T("aISA-A15 Sampling Mode\n")
					_T("TvOJn`l=%ld\n")
					_T("TvOI`l=%ld\n")
					_T("obt@TCY=%ld\n")
					_T("^C}l=%ld\n")
					_T("샂[h=%ld"),
					md.iChFirst, md.iChLast, md.cwBuffer, md.dwTimer, md.dwMode);

	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// TvOJn
	if (Aisa15wStartSampling(wLogSlot) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	ResultMessage(_T("aISA-A15 Sampling Started"));

/*---------------------------------------------------------------------------*/
	// TvOEXe[^X̎擾
	if (Aisa15wGetSamplingStatus(wLogSlot, &dwNumData, &dwStatus) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	wsprintf(szbuf, _T("TvOEXe[^X擾\n")
					_T("f[^=%ld\n")
					_T("Xe[^X=%ld"),
					dwNumData, dwStatus);

	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// TvOς݃f[^̎擾
	if (dwNumData)
	{
		pwData = (PWORD)malloc(dwNumData * sizeof(WORD));
		memset(pwData, 0, dwNumData * sizeof(WORD));

		if (Aisa15wGetData(wLogSlot, dwNumData, pwData) == FALSE)
		{
			ErrorMessage(wLogSlot);
			return 1;
		}

		wsprintf(szbuf, _T("TvOς݃f[^擾\n"));
		for (i = 0; i < (LONG)dwNumData && lstrlen(szbuf) < sizeof(szbuf) - sizeof(szTmp) ; i++)
		{
			wsprintf(szTmp, _T("%ld:%lxh  "), i, pwData[i]);

			strcat(szbuf, szTmp);

			if ((i + 1) % 4 == 0)	// 4 Ŋ؂
				strcat(szbuf, _T("\n"));
		}

		ResultMessage(szbuf);

		free(pwData);
	}

/*---------------------------------------------------------------------------*/
	// TvO~
	if (Aisa15wStopSampling(wLogSlot) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	ResultMessage(_T("aISA-A15 Sampling Stopped"));

/*---------------------------------------------------------------------------*/
	// O͏Ԃ̎擾
	if (Aisa15wGetExIn(wLogSlot, &dwExIn0, &dwExIn1, &dwExTrg) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	wsprintf(szbuf, _T("O͏Ԃ̎擾\n")
					_T("EXIN0̏=%lxh\n")
					_T("EXIN1̏=%lxh\n")
					_T("EXTRG̏=%lxh"),
					dwExIn0, dwExIn1, dwExTrg);

	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// aISA-A15̎gpJ
	if (Aisa15wClose(wLogSlot) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	ResultMessage(_T("aISA-A15 Closed"));

/*---------------------------------------------------------------------------*/
	// aisa15.dll ̎gpJ
	if (Aisa15wDllClose() == FALSE)
	{
		MessageBox(NULL, _T("DLL Unload error"), szTitle, MB_OK | MB_ICONSTOP);
		return 1;			// aisa15.dll ̃A[hɎs܂B
	}

	return 0;
}

// ʂ\
static void ResultMessage(LPCTSTR lpszbuf)
{
	MessageBox(NULL, lpszbuf, szTitle, MB_OK | MB_ICONINFORMATION);
}

// G[bZ[W\
static void ErrorMessage(WORD wLogSlot)
{
	DWORD dwRes = Aisa15wGetLastError(wLogSlot);
	TCHAR szbuf[50];

	switch (dwRes)
	{
		case AISA15_ERR_WRAPDLL:
			wsprintf(szbuf, _T("DLL Load error"));
			break;

		default:
			wsprintf(szbuf, _T("aISA-A15 error\n\n")
							_T("Error code: %08lxh"),
							dwRes);
			break;
	}

	MessageBox(NULL, szbuf, szTitle, MB_OK | MB_ICONSTOP);
}
